/* DummyGateway.c generated by valac 0.36.1, the Vala compiler
 * generated from DummyGateway.vala, do not modify */

/*
* Copyright (c) 2011-2017 elementary LLC (http://launchpad.net/pantheon-greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <lightdm.h>


#define TYPE_LOGIN_GATEWAY (login_gateway_get_type ())
#define LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_GATEWAY, LoginGateway))
#define IS_LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_GATEWAY))
#define LOGIN_GATEWAY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_GATEWAY, LoginGatewayIface))

typedef struct _LoginGateway LoginGateway;
typedef struct _LoginGatewayIface LoginGatewayIface;

#define TYPE_LOGIN_MASK (login_mask_get_type ())
#define LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_MASK, LoginMask))
#define IS_LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_MASK))
#define LOGIN_MASK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_MASK, LoginMaskIface))

typedef struct _LoginMask LoginMask;
typedef struct _LoginMaskIface LoginMaskIface;

#define TYPE_PROMPT_TYPE (prompt_type_get_type ())

#define TYPE_PROMPT_TEXT (prompt_text_get_type ())

#define TYPE_MESSAGE_TEXT (message_text_get_type ())

#define TYPE_DUMMY_GATEWAY (dummy_gateway_get_type ())
#define DUMMY_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DUMMY_GATEWAY, DummyGateway))
#define DUMMY_GATEWAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DUMMY_GATEWAY, DummyGatewayClass))
#define IS_DUMMY_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DUMMY_GATEWAY))
#define IS_DUMMY_GATEWAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DUMMY_GATEWAY))
#define DUMMY_GATEWAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DUMMY_GATEWAY, DummyGatewayClass))

typedef struct _DummyGateway DummyGateway;
typedef struct _DummyGatewayClass DummyGatewayClass;
typedef struct _DummyGatewayPrivate DummyGatewayPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;

typedef enum  {
	PROMPT_TYPE_SECRET,
	PROMPT_TYPE_QUESTION,
	PROMPT_TYPE_CONFIRM_LOGIN,
	PROMPT_TYPE_FPRINT
} PromptType;

typedef enum  {
	PROMPT_TEXT_USERNAME,
	PROMPT_TEXT_PASSWORD,
	PROMPT_TEXT_OTHER
} PromptText;

typedef enum  {
	MESSAGE_TEXT_FPRINT_SWIPE,
	MESSAGE_TEXT_FPRINT_SWIPE_AGAIN,
	MESSAGE_TEXT_FPRINT_SWIPE_TOO_SHORT,
	MESSAGE_TEXT_FPRINT_NOT_CENTERED,
	MESSAGE_TEXT_FPRINT_REMOVE,
	MESSAGE_TEXT_FPRINT_PLACE,
	MESSAGE_TEXT_FPRINT_PLACE_AGAIN,
	MESSAGE_TEXT_FPRINT_NO_MATCH,
	MESSAGE_TEXT_FPRINT_TIMEOUT,
	MESSAGE_TEXT_FPRINT_ERROR,
	MESSAGE_TEXT_FAILED,
	MESSAGE_TEXT_OTHER
} MessageText;

struct _LoginMaskIface {
	GTypeInterface parent_iface;
	void (*show_prompt) (LoginMask* self, PromptType type, PromptText prompttext, const gchar* text);
	void (*show_message) (LoginMask* self, LightDMMessageType type, MessageText messagetext, const gchar* text);
	void (*not_authenticated) (LoginMask* self);
	void (*login_aborted) (LoginMask* self);
	const gchar* (*get_login_name) (LoginMask* self);
	const gchar* (*get_login_session) (LoginMask* self);
};

struct _LoginGatewayIface {
	GTypeInterface parent_iface;
	void (*login_with_mask) (LoginGateway* self, LoginMask* mask, gboolean guest);
	void (*respond) (LoginGateway* self, const gchar* message);
	void (*start_session) (LoginGateway* self);
	gboolean (*get_hide_users) (LoginGateway* self);
	gboolean (*get_has_guest_account) (LoginGateway* self);
	gboolean (*get_show_manual_login) (LoginGateway* self);
	gboolean (*get_lock) (LoginGateway* self);
	const gchar* (*get_default_session) (LoginGateway* self);
	const gchar* (*get_select_user) (LoginGateway* self);
};

struct _DummyGateway {
	GObject parent_instance;
	DummyGatewayPrivate * priv;
};

struct _DummyGatewayClass {
	GObjectClass parent_class;
};

struct _DummyGatewayPrivate {
	LoginMask* last_login_mask;
	gboolean last_was_guest;
};

struct _Block3Data {
	int _ref_count_;
	DummyGateway* self;
	LoginMask* mask;
	gboolean guest;
};


static gpointer dummy_gateway_parent_class = NULL;
static LoginGatewayIface * dummy_gateway_login_gateway_parent_iface = NULL;

GType prompt_type_get_type (void) G_GNUC_CONST;
GType prompt_text_get_type (void) G_GNUC_CONST;
GType message_text_get_type (void) G_GNUC_CONST;
GType login_mask_get_type (void) G_GNUC_CONST;
GType login_gateway_get_type (void) G_GNUC_CONST;
GType dummy_gateway_get_type (void) G_GNUC_CONST;
#define DUMMY_GATEWAY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DUMMY_GATEWAY, DummyGatewayPrivate))
enum  {
	DUMMY_GATEWAY_DUMMY_PROPERTY,
	DUMMY_GATEWAY_HIDE_USERS,
	DUMMY_GATEWAY_HAS_GUEST_ACCOUNT,
	DUMMY_GATEWAY_SHOW_MANUAL_LOGIN,
	DUMMY_GATEWAY_LOCK,
	DUMMY_GATEWAY_DEFAULT_SESSION,
	DUMMY_GATEWAY_SELECT_USER
};
static void dummy_gateway_real_login_with_mask (LoginGateway* base, LoginMask* mask, gboolean guest);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
void login_mask_login_aborted (LoginMask* self);
static gboolean __lambda33_ (Block3Data* _data3_);
void login_mask_show_prompt (LoginMask* self, PromptType type, PromptText prompttext, const gchar* text);
static gboolean ___lambda33__gsource_func (gpointer self);
static void dummy_gateway_real_respond (LoginGateway* base, const gchar* message);
static gboolean ___lambda34_ (DummyGateway* self);
static gboolean ____lambda34__gsource_func (gpointer self);
static gboolean ___lambda35_ (DummyGateway* self);
void login_mask_not_authenticated (LoginMask* self);
static gboolean ____lambda35__gsource_func (gpointer self);
static void dummy_gateway_real_start_session (LoginGateway* base);
DummyGateway* dummy_gateway_new (void);
DummyGateway* dummy_gateway_construct (GType object_type);
static void dummy_gateway_finalize (GObject * obj);
gboolean login_gateway_get_hide_users (LoginGateway* self);
gboolean login_gateway_get_has_guest_account (LoginGateway* self);
gboolean login_gateway_get_show_manual_login (LoginGateway* self);
gboolean login_gateway_get_lock (LoginGateway* self);
const gchar* login_gateway_get_default_session (LoginGateway* self);
const gchar* login_gateway_get_select_user (LoginGateway* self);
static void _vala_dummy_gateway_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void block3_data_unref (void * _userdata_) {
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		DummyGateway* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->mask);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}


static gboolean __lambda33_ (Block3Data* _data3_) {
	DummyGateway* self;
	gboolean result = FALSE;
	PromptType _tmp0_ = 0;
	gboolean _tmp1_;
	PromptText _tmp2_ = 0;
	gboolean _tmp3_;
	LoginMask* _tmp4_;
	self = _data3_->self;
	_tmp1_ = _data3_->guest;
	if (_tmp1_) {
		_tmp0_ = PROMPT_TYPE_CONFIRM_LOGIN;
	} else {
		_tmp0_ = PROMPT_TYPE_SECRET;
	}
	_tmp3_ = _data3_->guest;
	if (_tmp3_) {
		_tmp2_ = PROMPT_TEXT_OTHER;
	} else {
		_tmp2_ = PROMPT_TEXT_PASSWORD;
	}
	_tmp4_ = _data3_->mask;
	login_mask_show_prompt (_tmp4_, _tmp0_, _tmp2_, "");
	result = FALSE;
	return result;
}


static gboolean ___lambda33__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda33_ (self);
	return result;
}


static void dummy_gateway_real_login_with_mask (LoginGateway* base, LoginMask* mask, gboolean guest) {
	DummyGateway * self;
	Block3Data* _data3_;
	LoginMask* _tmp0_;
	LoginMask* _tmp1_;
	gboolean _tmp2_;
	LoginMask* _tmp3_;
	gboolean _tmp5_;
	LoginMask* _tmp6_;
	LoginMask* _tmp7_;
	self = (DummyGateway*) base;
	g_return_if_fail (mask != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = mask;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data3_->mask);
	_data3_->mask = _tmp1_;
	_tmp2_ = guest;
	_data3_->guest = _tmp2_;
	_tmp3_ = self->priv->last_login_mask;
	if (_tmp3_ != NULL) {
		LoginMask* _tmp4_;
		_tmp4_ = _data3_->mask;
		login_mask_login_aborted (_tmp4_);
	}
	_tmp5_ = _data3_->guest;
	self->priv->last_was_guest = _tmp5_;
	_tmp6_ = _data3_->mask;
	_tmp7_ = _g_object_ref0 (_tmp6_);
	_g_object_unref0 (self->priv->last_login_mask);
	self->priv->last_login_mask = _tmp7_;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda33__gsource_func, block3_data_ref (_data3_), block3_data_unref);
	block3_data_unref (_data3_);
	_data3_ = NULL;
}


static gboolean ___lambda34_ (DummyGateway* self) {
	gboolean result = FALSE;
	g_signal_emit_by_name ((LoginGateway*) self, "login-successful");
	result = FALSE;
	return result;
}


static gboolean ____lambda34__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda34_ ((DummyGateway*) self);
	return result;
}


static gboolean ___lambda35_ (DummyGateway* self) {
	gboolean result = FALSE;
	LoginMask* _tmp0_;
	_tmp0_ = self->priv->last_login_mask;
	login_mask_not_authenticated (_tmp0_);
	result = FALSE;
	return result;
}


static gboolean ____lambda35__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda35_ ((DummyGateway*) self);
	return result;
}


static void dummy_gateway_real_respond (LoginGateway* base, const gchar* message) {
	DummyGateway * self;
	gboolean _tmp0_;
	self = (DummyGateway*) base;
	g_return_if_fail (message != NULL);
	_tmp0_ = self->priv->last_was_guest;
	if (_tmp0_) {
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda34__gsource_func, g_object_ref (self), g_object_unref);
	} else {
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda35__gsource_func, g_object_ref (self), g_object_unref);
	}
}


static void dummy_gateway_real_start_session (LoginGateway* base) {
	DummyGateway * self;
	self = (DummyGateway*) base;
	g_message ("DummyGateway.vala:64: Started session");
	exit (EXIT_SUCCESS);
}


DummyGateway* dummy_gateway_construct (GType object_type) {
	DummyGateway * self = NULL;
	self = (DummyGateway*) g_object_new (object_type, NULL);
	return self;
}


DummyGateway* dummy_gateway_new (void) {
	return dummy_gateway_construct (TYPE_DUMMY_GATEWAY);
}


static gboolean dummy_gateway_real_get_hide_users (LoginGateway* base) {
	gboolean result;
	DummyGateway* self;
	self = (DummyGateway*) base;
	result = FALSE;
	return result;
}


static gboolean dummy_gateway_real_get_has_guest_account (LoginGateway* base) {
	gboolean result;
	DummyGateway* self;
	self = (DummyGateway*) base;
	result = TRUE;
	return result;
}


static gboolean dummy_gateway_real_get_show_manual_login (LoginGateway* base) {
	gboolean result;
	DummyGateway* self;
	self = (DummyGateway*) base;
	result = TRUE;
	return result;
}


static gboolean dummy_gateway_real_get_lock (LoginGateway* base) {
	gboolean result;
	DummyGateway* self;
	self = (DummyGateway*) base;
	result = FALSE;
	return result;
}


static const gchar* dummy_gateway_real_get_default_session (LoginGateway* base) {
	const gchar* result;
	DummyGateway* self;
	self = (DummyGateway*) base;
	result = "";
	return result;
}


static const gchar* dummy_gateway_real_get_select_user (LoginGateway* base) {
	const gchar* result;
	DummyGateway* self;
	self = (DummyGateway*) base;
	result = NULL;
	return result;
}


static void dummy_gateway_class_init (DummyGatewayClass * klass) {
	dummy_gateway_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DummyGatewayPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_dummy_gateway_get_property;
	G_OBJECT_CLASS (klass)->finalize = dummy_gateway_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUMMY_GATEWAY_HIDE_USERS, g_param_spec_boolean ("hide-users", "hide-users", "hide-users", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUMMY_GATEWAY_HAS_GUEST_ACCOUNT, g_param_spec_boolean ("has-guest-account", "has-guest-account", "has-guest-account", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUMMY_GATEWAY_SHOW_MANUAL_LOGIN, g_param_spec_boolean ("show-manual-login", "show-manual-login", "show-manual-login", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUMMY_GATEWAY_LOCK, g_param_spec_boolean ("lock", "lock", "lock", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUMMY_GATEWAY_DEFAULT_SESSION, g_param_spec_string ("default-session", "default-session", "default-session", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUMMY_GATEWAY_SELECT_USER, g_param_spec_string ("select-user", "select-user", "select-user", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void dummy_gateway_login_gateway_interface_init (LoginGatewayIface * iface) {
	dummy_gateway_login_gateway_parent_iface = g_type_interface_peek_parent (iface);
	iface->login_with_mask = (void (*) (LoginGateway *, LoginMask*, gboolean)) dummy_gateway_real_login_with_mask;
	iface->respond = (void (*) (LoginGateway *, const gchar*)) dummy_gateway_real_respond;
	iface->start_session = (void (*) (LoginGateway *)) dummy_gateway_real_start_session;
	iface->get_hide_users = dummy_gateway_real_get_hide_users;
	iface->get_has_guest_account = dummy_gateway_real_get_has_guest_account;
	iface->get_show_manual_login = dummy_gateway_real_get_show_manual_login;
	iface->get_lock = dummy_gateway_real_get_lock;
	iface->get_default_session = dummy_gateway_real_get_default_session;
	iface->get_select_user = dummy_gateway_real_get_select_user;
}


static void dummy_gateway_instance_init (DummyGateway * self) {
	self->priv = DUMMY_GATEWAY_GET_PRIVATE (self);
	self->priv->last_was_guest = TRUE;
}


static void dummy_gateway_finalize (GObject * obj) {
	DummyGateway * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DUMMY_GATEWAY, DummyGateway);
	_g_object_unref0 (self->priv->last_login_mask);
	G_OBJECT_CLASS (dummy_gateway_parent_class)->finalize (obj);
}


/**
 * For testing purposes a Gateway which only allows the guest to login.
 */
GType dummy_gateway_get_type (void) {
	static volatile gsize dummy_gateway_type_id__volatile = 0;
	if (g_once_init_enter (&dummy_gateway_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DummyGatewayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dummy_gateway_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DummyGateway), 0, (GInstanceInitFunc) dummy_gateway_instance_init, NULL };
		static const GInterfaceInfo login_gateway_info = { (GInterfaceInitFunc) dummy_gateway_login_gateway_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType dummy_gateway_type_id;
		dummy_gateway_type_id = g_type_register_static (G_TYPE_OBJECT, "DummyGateway", &g_define_type_info, 0);
		g_type_add_interface_static (dummy_gateway_type_id, TYPE_LOGIN_GATEWAY, &login_gateway_info);
		g_once_init_leave (&dummy_gateway_type_id__volatile, dummy_gateway_type_id);
	}
	return dummy_gateway_type_id__volatile;
}


static void _vala_dummy_gateway_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DummyGateway * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DUMMY_GATEWAY, DummyGateway);
	switch (property_id) {
		case DUMMY_GATEWAY_HIDE_USERS:
		g_value_set_boolean (value, login_gateway_get_hide_users ((LoginGateway*) self));
		break;
		case DUMMY_GATEWAY_HAS_GUEST_ACCOUNT:
		g_value_set_boolean (value, login_gateway_get_has_guest_account ((LoginGateway*) self));
		break;
		case DUMMY_GATEWAY_SHOW_MANUAL_LOGIN:
		g_value_set_boolean (value, login_gateway_get_show_manual_login ((LoginGateway*) self));
		break;
		case DUMMY_GATEWAY_LOCK:
		g_value_set_boolean (value, login_gateway_get_lock ((LoginGateway*) self));
		break;
		case DUMMY_GATEWAY_DEFAULT_SESSION:
		g_value_set_string (value, login_gateway_get_default_session ((LoginGateway*) self));
		break;
		case DUMMY_GATEWAY_SELECT_USER:
		g_value_set_string (value, login_gateway_get_select_user ((LoginGateway*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



