/* GuestLogin.c generated by valac 0.36.1, the Vala compiler
 * generated from GuestLogin.vala, do not modify */

/*
* Copyright (c) 2016-2017 elementary LLC. (http://launchpad.net/pantheon-greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_LOGIN_OPTION (login_option_get_type ())
#define LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_OPTION, LoginOption))
#define LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOGIN_OPTION, LoginOptionClass))
#define IS_LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_OPTION))
#define IS_LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOGIN_OPTION))
#define LOGIN_OPTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOGIN_OPTION, LoginOptionClass))

typedef struct _LoginOption LoginOption;
typedef struct _LoginOptionClass LoginOptionClass;
typedef struct _LoginOptionPrivate LoginOptionPrivate;

#define TYPE_GUEST_LOGIN (guest_login_get_type ())
#define GUEST_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GUEST_LOGIN, GuestLogin))
#define GUEST_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GUEST_LOGIN, GuestLoginClass))
#define IS_GUEST_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GUEST_LOGIN))
#define IS_GUEST_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GUEST_LOGIN))
#define GUEST_LOGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GUEST_LOGIN, GuestLoginClass))

typedef struct _GuestLogin GuestLogin;
typedef struct _GuestLoginClass GuestLoginClass;
typedef struct _GuestLoginPrivate GuestLoginPrivate;

struct _LoginOption {
	GObject parent_instance;
	LoginOptionPrivate * priv;
};

struct _LoginOptionClass {
	GObjectClass parent_class;
	const gchar* (*get_display_name) (LoginOption* self);
	const gchar* (*get_avatar_path) (LoginOption* self);
	const gchar* (*get_background) (LoginOption* self);
	const gchar* (*get_name) (LoginOption* self);
	gboolean (*get_logged_in) (LoginOption* self);
	gboolean (*get_is_guest) (LoginOption* self);
	gboolean (*get_provides_login_name) (LoginOption* self);
	const gchar* (*get_session) (LoginOption* self);
};

struct _GuestLogin {
	LoginOption parent_instance;
	GuestLoginPrivate * priv;
};

struct _GuestLoginClass {
	LoginOptionClass parent_class;
};


static gpointer guest_login_parent_class = NULL;

GType login_option_get_type (void) G_GNUC_CONST;
GType guest_login_get_type (void) G_GNUC_CONST;
enum  {
	GUEST_LOGIN_DUMMY_PROPERTY,
	GUEST_LOGIN_IS_GUEST,
	GUEST_LOGIN_NAME,
	GUEST_LOGIN_DISPLAY_NAME
};
GuestLogin* guest_login_new (gint index);
GuestLogin* guest_login_construct (GType object_type, gint index);
LoginOption* login_option_construct (GType object_type, gint index);
gboolean login_option_get_is_guest (LoginOption* self);
const gchar* login_option_get_name (LoginOption* self);
const gchar* login_option_get_display_name (LoginOption* self);
static void _vala_guest_login_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);


GuestLogin* guest_login_construct (GType object_type, gint index) {
	GuestLogin * self = NULL;
	gint _tmp0_;
	_tmp0_ = index;
	self = (GuestLogin*) login_option_construct (object_type, _tmp0_);
	return self;
}


GuestLogin* guest_login_new (gint index) {
	return guest_login_construct (TYPE_GUEST_LOGIN, index);
}


static gboolean guest_login_real_get_is_guest (LoginOption* base) {
	gboolean result;
	GuestLogin* self;
	self = (GuestLogin*) base;
	result = TRUE;
	return result;
}


static const gchar* guest_login_real_get_name (LoginOption* base) {
	const gchar* result;
	GuestLogin* self;
	self = (GuestLogin*) base;
	result = "?pantheon greeter guest?";
	return result;
}


static const gchar* guest_login_real_get_display_name (LoginOption* base) {
	const gchar* result;
	GuestLogin* self;
	self = (GuestLogin*) base;
	result = _ ("Guest session");
	return result;
}


static void guest_login_class_init (GuestLoginClass * klass) {
	guest_login_parent_class = g_type_class_peek_parent (klass);
	LOGIN_OPTION_CLASS (klass)->get_is_guest = guest_login_real_get_is_guest;
	LOGIN_OPTION_CLASS (klass)->get_name = guest_login_real_get_name;
	LOGIN_OPTION_CLASS (klass)->get_display_name = guest_login_real_get_display_name;
	G_OBJECT_CLASS (klass)->get_property = _vala_guest_login_get_property;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GUEST_LOGIN_IS_GUEST, g_param_spec_boolean ("is-guest", "is-guest", "is-guest", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GUEST_LOGIN_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GUEST_LOGIN_DISPLAY_NAME, g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void guest_login_instance_init (GuestLogin * self) {
}


GType guest_login_get_type (void) {
	static volatile gsize guest_login_type_id__volatile = 0;
	if (g_once_init_enter (&guest_login_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GuestLoginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) guest_login_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GuestLogin), 0, (GInstanceInitFunc) guest_login_instance_init, NULL };
		GType guest_login_type_id;
		guest_login_type_id = g_type_register_static (TYPE_LOGIN_OPTION, "GuestLogin", &g_define_type_info, 0);
		g_once_init_leave (&guest_login_type_id__volatile, guest_login_type_id);
	}
	return guest_login_type_id__volatile;
}


static void _vala_guest_login_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GuestLogin * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GUEST_LOGIN, GuestLogin);
	switch (property_id) {
		case GUEST_LOGIN_IS_GUEST:
		g_value_set_boolean (value, login_option_get_is_guest ((LoginOption*) self));
		break;
		case GUEST_LOGIN_NAME:
		g_value_set_string (value, login_option_get_name ((LoginOption*) self));
		break;
		case GUEST_LOGIN_DISPLAY_NAME:
		g_value_set_string (value, login_option_get_display_name ((LoginOption*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



