/* LoginOption.c generated by valac 0.36.1, the Vala compiler
 * generated from LoginOption.vala, do not modify */

/*
* Copyright (c) 2011-2017 elementary LLC. (http://launchpad.net/pantheon-greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <lightdm.h>


#define TYPE_LOGIN_OPTION (login_option_get_type ())
#define LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_OPTION, LoginOption))
#define LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOGIN_OPTION, LoginOptionClass))
#define IS_LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_OPTION))
#define IS_LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOGIN_OPTION))
#define LOGIN_OPTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOGIN_OPTION, LoginOptionClass))

typedef struct _LoginOption LoginOption;
typedef struct _LoginOptionClass LoginOptionClass;
typedef struct _LoginOptionPrivate LoginOptionPrivate;

#define TYPE_LOGIN_GATEWAY (login_gateway_get_type ())
#define LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_GATEWAY, LoginGateway))
#define IS_LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_GATEWAY))
#define LOGIN_GATEWAY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_GATEWAY, LoginGatewayIface))

typedef struct _LoginGateway LoginGateway;
typedef struct _LoginGatewayIface LoginGatewayIface;

#define TYPE_LOGIN_MASK (login_mask_get_type ())
#define LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_MASK, LoginMask))
#define IS_LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_MASK))
#define LOGIN_MASK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_MASK, LoginMaskIface))

typedef struct _LoginMask LoginMask;
typedef struct _LoginMaskIface LoginMaskIface;

#define TYPE_PROMPT_TYPE (prompt_type_get_type ())

#define TYPE_PROMPT_TEXT (prompt_text_get_type ())

#define TYPE_MESSAGE_TEXT (message_text_get_type ())

struct _LoginOption {
	GObject parent_instance;
	LoginOptionPrivate * priv;
};

struct _LoginOptionClass {
	GObjectClass parent_class;
	const gchar* (*get_display_name) (LoginOption* self);
	const gchar* (*get_avatar_path) (LoginOption* self);
	const gchar* (*get_background) (LoginOption* self);
	const gchar* (*get_name) (LoginOption* self);
	gboolean (*get_logged_in) (LoginOption* self);
	gboolean (*get_is_guest) (LoginOption* self);
	gboolean (*get_provides_login_name) (LoginOption* self);
	const gchar* (*get_session) (LoginOption* self);
};

struct _LoginOptionPrivate {
	gint _index;
};

typedef enum  {
	PROMPT_TYPE_SECRET,
	PROMPT_TYPE_QUESTION,
	PROMPT_TYPE_CONFIRM_LOGIN,
	PROMPT_TYPE_FPRINT
} PromptType;

typedef enum  {
	PROMPT_TEXT_USERNAME,
	PROMPT_TEXT_PASSWORD,
	PROMPT_TEXT_OTHER
} PromptText;

typedef enum  {
	MESSAGE_TEXT_FPRINT_SWIPE,
	MESSAGE_TEXT_FPRINT_SWIPE_AGAIN,
	MESSAGE_TEXT_FPRINT_SWIPE_TOO_SHORT,
	MESSAGE_TEXT_FPRINT_NOT_CENTERED,
	MESSAGE_TEXT_FPRINT_REMOVE,
	MESSAGE_TEXT_FPRINT_PLACE,
	MESSAGE_TEXT_FPRINT_PLACE_AGAIN,
	MESSAGE_TEXT_FPRINT_NO_MATCH,
	MESSAGE_TEXT_FPRINT_TIMEOUT,
	MESSAGE_TEXT_FPRINT_ERROR,
	MESSAGE_TEXT_FAILED,
	MESSAGE_TEXT_OTHER
} MessageText;

struct _LoginMaskIface {
	GTypeInterface parent_iface;
	void (*show_prompt) (LoginMask* self, PromptType type, PromptText prompttext, const gchar* text);
	void (*show_message) (LoginMask* self, LightDMMessageType type, MessageText messagetext, const gchar* text);
	void (*not_authenticated) (LoginMask* self);
	void (*login_aborted) (LoginMask* self);
	const gchar* (*get_login_name) (LoginMask* self);
	const gchar* (*get_login_session) (LoginMask* self);
};

struct _LoginGatewayIface {
	GTypeInterface parent_iface;
	void (*login_with_mask) (LoginGateway* self, LoginMask* mask, gboolean guest);
	void (*respond) (LoginGateway* self, const gchar* message);
	void (*start_session) (LoginGateway* self);
	gboolean (*get_hide_users) (LoginGateway* self);
	gboolean (*get_has_guest_account) (LoginGateway* self);
	gboolean (*get_show_manual_login) (LoginGateway* self);
	gboolean (*get_lock) (LoginGateway* self);
	const gchar* (*get_default_session) (LoginGateway* self);
	const gchar* (*get_select_user) (LoginGateway* self);
};


static gpointer login_option_parent_class = NULL;

GType login_option_get_type (void) G_GNUC_CONST;
#define LOGIN_OPTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LOGIN_OPTION, LoginOptionPrivate))
enum  {
	LOGIN_OPTION_DUMMY_PROPERTY,
	LOGIN_OPTION_INDEX,
	LOGIN_OPTION_DISPLAY_NAME,
	LOGIN_OPTION_AVATAR_PATH,
	LOGIN_OPTION_BACKGROUND,
	LOGIN_OPTION_NAME,
	LOGIN_OPTION_LOGGED_IN,
	LOGIN_OPTION_IS_GUEST,
	LOGIN_OPTION_PROVIDES_LOGIN_NAME,
	LOGIN_OPTION_SESSION
};
LoginOption* login_option_construct (GType object_type, gint index);
static void login_option_set_index (LoginOption* self, gint value);
gchar* login_option_get_markup (LoginOption* self);
const gchar* login_option_get_display_name (LoginOption* self);
gint login_option_get_index (LoginOption* self);
const gchar* login_option_get_avatar_path (LoginOption* self);
const gchar* login_option_get_background (LoginOption* self);
const gchar* login_option_get_name (LoginOption* self);
gboolean login_option_get_logged_in (LoginOption* self);
gboolean login_option_get_is_guest (LoginOption* self);
gboolean login_option_get_provides_login_name (LoginOption* self);
const gchar* login_option_get_session (LoginOption* self);
GType prompt_type_get_type (void) G_GNUC_CONST;
GType prompt_text_get_type (void) G_GNUC_CONST;
GType message_text_get_type (void) G_GNUC_CONST;
GType login_mask_get_type (void) G_GNUC_CONST;
GType login_gateway_get_type (void) G_GNUC_CONST;
LoginGateway* pantheon_greeter_get_login_gateway (void);
const gchar* login_gateway_get_default_session (LoginGateway* self);
static void login_option_finalize (GObject * obj);
static void _vala_login_option_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_login_option_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


LoginOption* login_option_construct (GType object_type, gint index) {
	LoginOption * self = NULL;
	gint _tmp0_;
	self = (LoginOption*) g_object_new (object_type, NULL);
	_tmp0_ = index;
	login_option_set_index (self, _tmp0_);
	return self;
}


gchar* login_option_get_markup (LoginOption* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = login_option_get_display_name (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup (_tmp1_);
	result = _tmp2_;
	return result;
}


gint login_option_get_index (LoginOption* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_index;
	result = _tmp0_;
	return result;
}


static void login_option_set_index (LoginOption* self, gint value) {
	g_return_if_fail (self != NULL);
	if (login_option_get_index (self) != value) {
		gint _tmp0_;
		_tmp0_ = value;
		self->priv->_index = _tmp0_;
		g_object_notify ((GObject *) self, "index");
	}
}


const gchar* login_option_get_display_name (LoginOption* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return LOGIN_OPTION_GET_CLASS (self)->get_display_name (self);
}


const gchar* login_option_get_avatar_path (LoginOption* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return LOGIN_OPTION_GET_CLASS (self)->get_avatar_path (self);
}


static const gchar* login_option_real_get_avatar_path (LoginOption* base) {
	const gchar* result;
	LoginOption* self;
	self = base;
	result = NULL;
	return result;
}


const gchar* login_option_get_background (LoginOption* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return LOGIN_OPTION_GET_CLASS (self)->get_background (self);
}


static const gchar* login_option_real_get_background (LoginOption* base) {
	const gchar* result;
	LoginOption* self;
	self = base;
	result = "";
	return result;
}


const gchar* login_option_get_name (LoginOption* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return LOGIN_OPTION_GET_CLASS (self)->get_name (self);
}


gboolean login_option_get_logged_in (LoginOption* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return LOGIN_OPTION_GET_CLASS (self)->get_logged_in (self);
}


static gboolean login_option_real_get_logged_in (LoginOption* base) {
	gboolean result;
	LoginOption* self;
	self = base;
	result = FALSE;
	return result;
}


gboolean login_option_get_is_guest (LoginOption* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return LOGIN_OPTION_GET_CLASS (self)->get_is_guest (self);
}


static gboolean login_option_real_get_is_guest (LoginOption* base) {
	gboolean result;
	LoginOption* self;
	self = base;
	result = FALSE;
	return result;
}


gboolean login_option_get_provides_login_name (LoginOption* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return LOGIN_OPTION_GET_CLASS (self)->get_provides_login_name (self);
}


static gboolean login_option_real_get_provides_login_name (LoginOption* base) {
	gboolean result;
	LoginOption* self;
	self = base;
	result = TRUE;
	return result;
}


const gchar* login_option_get_session (LoginOption* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return LOGIN_OPTION_GET_CLASS (self)->get_session (self);
}


static const gchar* login_option_real_get_session (LoginOption* base) {
	const gchar* result;
	LoginOption* self;
	LoginGateway* _tmp0_;
	LoginGateway* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	self = base;
	_tmp0_ = pantheon_greeter_get_login_gateway ();
	_tmp1_ = _tmp0_;
	_tmp2_ = login_gateway_get_default_session (_tmp1_);
	_tmp3_ = _tmp2_;
	result = _tmp3_;
	return result;
}


static void login_option_class_init (LoginOptionClass * klass) {
	login_option_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (LoginOptionPrivate));
	LOGIN_OPTION_CLASS (klass)->get_avatar_path = login_option_real_get_avatar_path;
	LOGIN_OPTION_CLASS (klass)->get_background = login_option_real_get_background;
	LOGIN_OPTION_CLASS (klass)->get_logged_in = login_option_real_get_logged_in;
	LOGIN_OPTION_CLASS (klass)->get_is_guest = login_option_real_get_is_guest;
	LOGIN_OPTION_CLASS (klass)->get_provides_login_name = login_option_real_get_provides_login_name;
	LOGIN_OPTION_CLASS (klass)->get_session = login_option_real_get_session;
	G_OBJECT_CLASS (klass)->get_property = _vala_login_option_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_login_option_set_property;
	G_OBJECT_CLASS (klass)->finalize = login_option_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_INDEX, g_param_spec_int ("index", "index", "index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * The name of this login how it shall be presented to the user.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_DISPLAY_NAME, g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * Path to the avatar of this user or null
	     * in case he has none.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_AVATAR_PATH, g_param_spec_string ("avatar-path", "avatar-path", "avatar-path", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * Path to the background-image of this user or ""
	     * in case he has none.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_BACKGROUND, g_param_spec_string ("background", "background", "background", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * The login name for this LoginOption. This is also used to identify this object
	     * from one session to another. Note that you still have to return a unique
	     * string even if this LoginOption cannot directly provide a login name to
	     * identify this entry.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * True if and only if this user is currently logged in.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_LOGGED_IN, g_param_spec_boolean ("logged-in", "logged-in", "logged-in", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * If this LoginOption is for a guest-user. This is necessary
	     * as LightDM handles guests in a special way.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_IS_GUEST, g_param_spec_boolean ("is-guest", "is-guest", "is-guest", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * True if this LoginOption provides the necessary information to determine
	     * the login name. This is for example used by the LoginBox to decide if
	     * a Entry for a login name is necessary or not.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_PROVIDES_LOGIN_NAME, g_param_spec_boolean ("provides-login-name", "provides-login-name", "provides-login-name", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * The name of the session that this user wants by default.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_SESSION, g_param_spec_string ("session", "session", "session", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void login_option_instance_init (LoginOption * self) {
	self->priv = LOGIN_OPTION_GET_PRIVATE (self);
}


static void login_option_finalize (GObject * obj) {
	LoginOption * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LOGIN_OPTION, LoginOption);
	G_OBJECT_CLASS (login_option_parent_class)->finalize (obj);
}


GType login_option_get_type (void) {
	static volatile gsize login_option_type_id__volatile = 0;
	if (g_once_init_enter (&login_option_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LoginOptionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) login_option_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LoginOption), 0, (GInstanceInitFunc) login_option_instance_init, NULL };
		GType login_option_type_id;
		login_option_type_id = g_type_register_static (G_TYPE_OBJECT, "LoginOption", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&login_option_type_id__volatile, login_option_type_id);
	}
	return login_option_type_id__volatile;
}


static void _vala_login_option_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	LoginOption * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LOGIN_OPTION, LoginOption);
	switch (property_id) {
		case LOGIN_OPTION_INDEX:
		g_value_set_int (value, login_option_get_index (self));
		break;
		case LOGIN_OPTION_AVATAR_PATH:
		g_value_set_string (value, login_option_get_avatar_path (self));
		break;
		case LOGIN_OPTION_BACKGROUND:
		g_value_set_string (value, login_option_get_background (self));
		break;
		case LOGIN_OPTION_LOGGED_IN:
		g_value_set_boolean (value, login_option_get_logged_in (self));
		break;
		case LOGIN_OPTION_IS_GUEST:
		g_value_set_boolean (value, login_option_get_is_guest (self));
		break;
		case LOGIN_OPTION_PROVIDES_LOGIN_NAME:
		g_value_set_boolean (value, login_option_get_provides_login_name (self));
		break;
		case LOGIN_OPTION_SESSION:
		g_value_set_string (value, login_option_get_session (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_login_option_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	LoginOption * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LOGIN_OPTION, LoginOption);
	switch (property_id) {
		case LOGIN_OPTION_INDEX:
		login_option_set_index (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



