/* UserLogin.c generated by valac 0.36.1, the Vala compiler
 * generated from UserLogin.vala, do not modify */

/*
* Copyright (c) 2016-2017 elementary LLC. (http://launchpad.net/pantheon-greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <lightdm.h>


#define TYPE_LOGIN_OPTION (login_option_get_type ())
#define LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_OPTION, LoginOption))
#define LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOGIN_OPTION, LoginOptionClass))
#define IS_LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_OPTION))
#define IS_LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOGIN_OPTION))
#define LOGIN_OPTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOGIN_OPTION, LoginOptionClass))

typedef struct _LoginOption LoginOption;
typedef struct _LoginOptionClass LoginOptionClass;
typedef struct _LoginOptionPrivate LoginOptionPrivate;

#define TYPE_USER_LOGIN (user_login_get_type ())
#define USER_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_LOGIN, UserLogin))
#define USER_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_LOGIN, UserLoginClass))
#define IS_USER_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_LOGIN))
#define IS_USER_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_LOGIN))
#define USER_LOGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_LOGIN, UserLoginClass))

typedef struct _UserLogin UserLogin;
typedef struct _UserLoginClass UserLoginClass;
typedef struct _UserLoginPrivate UserLoginPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _LoginOption {
	GObject parent_instance;
	LoginOptionPrivate * priv;
};

struct _LoginOptionClass {
	GObjectClass parent_class;
	const gchar* (*get_display_name) (LoginOption* self);
	const gchar* (*get_avatar_path) (LoginOption* self);
	const gchar* (*get_background) (LoginOption* self);
	const gchar* (*get_name) (LoginOption* self);
	gboolean (*get_logged_in) (LoginOption* self);
	gboolean (*get_is_guest) (LoginOption* self);
	gboolean (*get_provides_login_name) (LoginOption* self);
	const gchar* (*get_session) (LoginOption* self);
};

struct _UserLogin {
	LoginOption parent_instance;
	UserLoginPrivate * priv;
};

struct _UserLoginClass {
	LoginOptionClass parent_class;
};

struct _UserLoginPrivate {
	LightDMUser* _lightdm_user;
};


static gpointer user_login_parent_class = NULL;

GType login_option_get_type (void) G_GNUC_CONST;
GType user_login_get_type (void) G_GNUC_CONST;
#define USER_LOGIN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_USER_LOGIN, UserLoginPrivate))
enum  {
	USER_LOGIN_DUMMY_PROPERTY,
	USER_LOGIN_LIGHTDM_USER,
	USER_LOGIN_AVATAR_PATH,
	USER_LOGIN_BACKGROUND,
	USER_LOGIN_DISPLAY_NAME,
	USER_LOGIN_NAME,
	USER_LOGIN_LOGGED_IN,
	USER_LOGIN_SESSION
};
UserLogin* user_login_new (gint index, LightDMUser* user);
UserLogin* user_login_construct (GType object_type, gint index, LightDMUser* user);
LoginOption* login_option_construct (GType object_type, gint index);
static void user_login_set_lightdm_user (UserLogin* self, LightDMUser* value);
LightDMUser* user_login_get_lightdm_user (UserLogin* self);
static void user_login_finalize (GObject * obj);
const gchar* login_option_get_avatar_path (LoginOption* self);
const gchar* login_option_get_background (LoginOption* self);
const gchar* login_option_get_display_name (LoginOption* self);
const gchar* login_option_get_name (LoginOption* self);
gboolean login_option_get_logged_in (LoginOption* self);
const gchar* login_option_get_session (LoginOption* self);
static void _vala_user_login_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_user_login_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


UserLogin* user_login_construct (GType object_type, gint index, LightDMUser* user) {
	UserLogin * self = NULL;
	gint _tmp0_;
	LightDMUser* _tmp1_;
	g_return_val_if_fail (user != NULL, NULL);
	_tmp0_ = index;
	self = (UserLogin*) login_option_construct (object_type, _tmp0_);
	_tmp1_ = user;
	user_login_set_lightdm_user (self, _tmp1_);
	return self;
}


UserLogin* user_login_new (gint index, LightDMUser* user) {
	return user_login_construct (TYPE_USER_LOGIN, index, user);
}


LightDMUser* user_login_get_lightdm_user (UserLogin* self) {
	LightDMUser* result;
	LightDMUser* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_lightdm_user;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void user_login_set_lightdm_user (UserLogin* self, LightDMUser* value) {
	g_return_if_fail (self != NULL);
	if (user_login_get_lightdm_user (self) != value) {
		LightDMUser* _tmp0_;
		LightDMUser* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_lightdm_user);
		self->priv->_lightdm_user = _tmp1_;
		g_object_notify ((GObject *) self, "lightdm-user");
	}
}


static const gchar* user_login_real_get_avatar_path (LoginOption* base) {
	const gchar* result;
	UserLogin* self;
	LightDMUser* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (UserLogin*) base;
	_tmp0_ = self->priv->_lightdm_user;
	_tmp1_ = lightdm_user_get_image (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static const gchar* user_login_real_get_background (LoginOption* base) {
	const gchar* result;
	UserLogin* self;
	LightDMUser* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (UserLogin*) base;
	_tmp0_ = self->priv->_lightdm_user;
	_tmp1_ = lightdm_user_get_background (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static const gchar* user_login_real_get_display_name (LoginOption* base) {
	const gchar* result;
	UserLogin* self;
	LightDMUser* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (UserLogin*) base;
	_tmp0_ = self->priv->_lightdm_user;
	_tmp1_ = lightdm_user_get_display_name (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static const gchar* user_login_real_get_name (LoginOption* base) {
	const gchar* result;
	UserLogin* self;
	LightDMUser* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (UserLogin*) base;
	_tmp0_ = self->priv->_lightdm_user;
	_tmp1_ = lightdm_user_get_name (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static gboolean user_login_real_get_logged_in (LoginOption* base) {
	gboolean result;
	UserLogin* self;
	LightDMUser* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = (UserLogin*) base;
	_tmp0_ = self->priv->_lightdm_user;
	_tmp1_ = lightdm_user_get_logged_in (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static const gchar* user_login_real_get_session (LoginOption* base) {
	const gchar* result;
	UserLogin* self;
	LightDMUser* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (UserLogin*) base;
	_tmp0_ = self->priv->_lightdm_user;
	_tmp1_ = lightdm_user_get_session (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static void user_login_class_init (UserLoginClass * klass) {
	user_login_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (UserLoginPrivate));
	LOGIN_OPTION_CLASS (klass)->get_avatar_path = user_login_real_get_avatar_path;
	LOGIN_OPTION_CLASS (klass)->get_background = user_login_real_get_background;
	LOGIN_OPTION_CLASS (klass)->get_display_name = user_login_real_get_display_name;
	LOGIN_OPTION_CLASS (klass)->get_name = user_login_real_get_name;
	LOGIN_OPTION_CLASS (klass)->get_logged_in = user_login_real_get_logged_in;
	LOGIN_OPTION_CLASS (klass)->get_session = user_login_real_get_session;
	G_OBJECT_CLASS (klass)->get_property = _vala_user_login_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_user_login_set_property;
	G_OBJECT_CLASS (klass)->finalize = user_login_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_LIGHTDM_USER, g_param_spec_object ("lightdm-user", "lightdm-user", "lightdm-user", lightdm_user_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_AVATAR_PATH, g_param_spec_string ("avatar-path", "avatar-path", "avatar-path", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_BACKGROUND, g_param_spec_string ("background", "background", "background", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_DISPLAY_NAME, g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_LOGGED_IN, g_param_spec_boolean ("logged-in", "logged-in", "logged-in", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_SESSION, g_param_spec_string ("session", "session", "session", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void user_login_instance_init (UserLogin * self) {
	self->priv = USER_LOGIN_GET_PRIVATE (self);
}


static void user_login_finalize (GObject * obj) {
	UserLogin * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_LOGIN, UserLogin);
	_g_object_unref0 (self->priv->_lightdm_user);
	G_OBJECT_CLASS (user_login_parent_class)->finalize (obj);
}


GType user_login_get_type (void) {
	static volatile gsize user_login_type_id__volatile = 0;
	if (g_once_init_enter (&user_login_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UserLoginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_login_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserLogin), 0, (GInstanceInitFunc) user_login_instance_init, NULL };
		GType user_login_type_id;
		user_login_type_id = g_type_register_static (TYPE_LOGIN_OPTION, "UserLogin", &g_define_type_info, 0);
		g_once_init_leave (&user_login_type_id__volatile, user_login_type_id);
	}
	return user_login_type_id__volatile;
}


static void _vala_user_login_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	UserLogin * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_LOGIN, UserLogin);
	switch (property_id) {
		case USER_LOGIN_LIGHTDM_USER:
		g_value_set_object (value, user_login_get_lightdm_user (self));
		break;
		case USER_LOGIN_AVATAR_PATH:
		g_value_set_string (value, login_option_get_avatar_path ((LoginOption*) self));
		break;
		case USER_LOGIN_BACKGROUND:
		g_value_set_string (value, login_option_get_background ((LoginOption*) self));
		break;
		case USER_LOGIN_DISPLAY_NAME:
		g_value_set_string (value, login_option_get_display_name ((LoginOption*) self));
		break;
		case USER_LOGIN_NAME:
		g_value_set_string (value, login_option_get_name ((LoginOption*) self));
		break;
		case USER_LOGIN_LOGGED_IN:
		g_value_set_boolean (value, login_option_get_logged_in ((LoginOption*) self));
		break;
		case USER_LOGIN_SESSION:
		g_value_set_string (value, login_option_get_session ((LoginOption*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_user_login_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	UserLogin * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_LOGIN, UserLogin);
	switch (property_id) {
		case USER_LOGIN_LIGHTDM_USER:
		user_login_set_lightdm_user (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



