/* PasswordArea.c generated by valac 0.36.1, the Vala compiler
 * generated from PasswordArea.vala, do not modify */

/*
* Copyright (c) 2011-2017 elementary LLC. (http://launchpad.net/pantheon-greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <lightdm.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>


#define TYPE_CREDENTIALS_AREA (credentials_area_get_type ())
#define CREDENTIALS_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CREDENTIALS_AREA, CredentialsArea))
#define CREDENTIALS_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CREDENTIALS_AREA, CredentialsAreaClass))
#define IS_CREDENTIALS_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CREDENTIALS_AREA))
#define IS_CREDENTIALS_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CREDENTIALS_AREA))
#define CREDENTIALS_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CREDENTIALS_AREA, CredentialsAreaClass))

typedef struct _CredentialsArea CredentialsArea;
typedef struct _CredentialsAreaClass CredentialsAreaClass;
typedef struct _CredentialsAreaPrivate CredentialsAreaPrivate;

#define TYPE_MESSAGE_TEXT (message_text_get_type ())

#define TYPE_PASSWORD_AREA (password_area_get_type ())
#define PASSWORD_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PASSWORD_AREA, PasswordArea))
#define PASSWORD_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PASSWORD_AREA, PasswordAreaClass))
#define IS_PASSWORD_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PASSWORD_AREA))
#define IS_PASSWORD_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PASSWORD_AREA))
#define PASSWORD_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PASSWORD_AREA, PasswordAreaClass))

typedef struct _PasswordArea PasswordArea;
typedef struct _PasswordAreaClass PasswordAreaClass;
typedef struct _PasswordAreaPrivate PasswordAreaPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef enum  {
	MESSAGE_TEXT_FPRINT_SWIPE,
	MESSAGE_TEXT_FPRINT_SWIPE_AGAIN,
	MESSAGE_TEXT_FPRINT_SWIPE_TOO_SHORT,
	MESSAGE_TEXT_FPRINT_NOT_CENTERED,
	MESSAGE_TEXT_FPRINT_REMOVE,
	MESSAGE_TEXT_FPRINT_PLACE,
	MESSAGE_TEXT_FPRINT_PLACE_AGAIN,
	MESSAGE_TEXT_FPRINT_NO_MATCH,
	MESSAGE_TEXT_FPRINT_TIMEOUT,
	MESSAGE_TEXT_FPRINT_ERROR,
	MESSAGE_TEXT_FAILED,
	MESSAGE_TEXT_OTHER
} MessageText;

struct _CredentialsArea {
	GtkGrid parent_instance;
	CredentialsAreaPrivate * priv;
};

struct _CredentialsAreaClass {
	GtkGridClass parent_class;
	void (*pass_focus) (CredentialsArea* self);
	void (*show_message) (CredentialsArea* self, LightDMMessageType type, MessageText messagetext, const gchar* text);
};

struct _PasswordArea {
	CredentialsArea parent_instance;
	PasswordAreaPrivate * priv;
};

struct _PasswordAreaClass {
	CredentialsAreaClass parent_class;
};

struct _PasswordAreaPrivate {
	GtkEntry* password;
};


static gpointer password_area_parent_class = NULL;

GType credentials_area_get_type (void) G_GNUC_CONST;
GType message_text_get_type (void) G_GNUC_CONST;
GType password_area_get_type (void) G_GNUC_CONST;
#define PASSWORD_AREA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PASSWORD_AREA, PasswordAreaPrivate))
enum  {
	PASSWORD_AREA_DUMMY_PROPERTY
};
PasswordArea* password_area_new (void);
PasswordArea* password_area_construct (GType object_type);
CredentialsArea* credentials_area_construct (GType object_type);
static void password_area_real_pass_focus (CredentialsArea* base);
static void password_area_real_show_message (CredentialsArea* base, LightDMMessageType type, MessageText messagetext, const gchar* text);
static GObject * password_area_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _password_area___lambda11_ (PasswordArea* self);
static void __password_area___lambda11__gtk_entry_activate (GtkEntry* _sender, gpointer self);
static void _password_area___lambda12_ (PasswordArea* self, GtkEntryIconPosition pos, GdkEvent* event);
static void __password_area___lambda12__gtk_entry_icon_press (GtkEntry* _sender, GtkEntryIconPosition p0, GdkEvent* p1, gpointer self);
static void password_area_finalize (GObject * obj);


PasswordArea* password_area_construct (GType object_type) {
	PasswordArea * self = NULL;
	self = (PasswordArea*) credentials_area_construct (object_type);
	return self;
}


PasswordArea* password_area_new (void) {
	return password_area_construct (TYPE_PASSWORD_AREA);
}


static void password_area_real_pass_focus (CredentialsArea* base) {
	PasswordArea * self;
	GtkEntry* _tmp0_;
	self = (PasswordArea*) base;
	_tmp0_ = self->priv->password;
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
}


static void password_area_real_show_message (CredentialsArea* base, LightDMMessageType type, MessageText messagetext, const gchar* text) {
	PasswordArea * self;
	self = (PasswordArea*) base;
	g_return_if_fail (text != NULL);
}


static void _password_area___lambda11_ (PasswordArea* self) {
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = self->priv->password;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_emit_by_name ((CredentialsArea*) self, "replied", _tmp2_);
}


static void __password_area___lambda11__gtk_entry_activate (GtkEntry* _sender, gpointer self) {
	_password_area___lambda11_ ((PasswordArea*) self);
}


static void _password_area___lambda12_ (PasswordArea* self, GtkEntryIconPosition pos, GdkEvent* event) {
	GtkEntryIconPosition _tmp0_;
	g_return_if_fail (event != NULL);
	_tmp0_ = pos;
	if (_tmp0_ == GTK_ENTRY_ICON_SECONDARY) {
		GtkEntry* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		_tmp1_ = self->priv->password;
		_tmp2_ = gtk_entry_get_text (_tmp1_);
		_tmp3_ = _tmp2_;
		g_signal_emit_by_name ((CredentialsArea*) self, "replied", _tmp3_);
	}
}


static void __password_area___lambda12__gtk_entry_icon_press (GtkEntry* _sender, GtkEntryIconPosition p0, GdkEvent* p1, gpointer self) {
	_password_area___lambda12_ ((PasswordArea*) self, p0, p1);
}


static GObject * password_area_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PasswordArea * self;
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
	GtkEntry* _tmp3_;
	GtkEntry* _tmp4_;
	GtkEntry* _tmp5_;
	GtkEntry* _tmp6_;
	GtkEntry* _tmp7_;
	GtkEntry* _tmp8_;
	GtkEntry* _tmp9_;
	parent_class = G_OBJECT_CLASS (password_area_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PASSWORD_AREA, PasswordArea);
	_tmp0_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->password);
	self->priv->password = _tmp0_;
	_tmp1_ = self->priv->password;
	g_object_set (_tmp1_, "caps-lock-warning", TRUE, NULL);
	_tmp2_ = self->priv->password;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
	_tmp3_ = self->priv->password;
	gtk_entry_set_icon_from_icon_name (_tmp3_, GTK_ENTRY_ICON_PRIMARY, "dialog-password-symbolic");
	_tmp4_ = self->priv->password;
	gtk_entry_set_icon_from_icon_name (_tmp4_, GTK_ENTRY_ICON_SECONDARY, "go-jump-symbolic");
	_tmp5_ = self->priv->password;
	gtk_entry_set_icon_tooltip_text (_tmp5_, GTK_ENTRY_ICON_SECONDARY, _ ("Log In"));
	_tmp6_ = self->priv->password;
	gtk_entry_set_visibility (_tmp6_, FALSE);
	_tmp7_ = self->priv->password;
	g_signal_connect_object (_tmp7_, "activate", (GCallback) __password_area___lambda11__gtk_entry_activate, self, 0);
	_tmp8_ = self->priv->password;
	g_signal_connect_object (_tmp8_, "icon-press", (GCallback) __password_area___lambda12__gtk_entry_icon_press, self, 0);
	_tmp9_ = self->priv->password;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp9_, 0, 0, 1, 1);
	return obj;
}


static void password_area_class_init (PasswordAreaClass * klass) {
	password_area_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PasswordAreaPrivate));
	((CredentialsAreaClass *) klass)->pass_focus = (void (*) (CredentialsArea *)) password_area_real_pass_focus;
	((CredentialsAreaClass *) klass)->show_message = (void (*) (CredentialsArea *, LightDMMessageType, MessageText, const gchar*)) password_area_real_show_message;
	G_OBJECT_CLASS (klass)->constructor = password_area_constructor;
	G_OBJECT_CLASS (klass)->finalize = password_area_finalize;
}


static void password_area_instance_init (PasswordArea * self) {
	self->priv = PASSWORD_AREA_GET_PRIVATE (self);
}


static void password_area_finalize (GObject * obj) {
	PasswordArea * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PASSWORD_AREA, PasswordArea);
	_g_object_unref0 (self->priv->password);
	G_OBJECT_CLASS (password_area_parent_class)->finalize (obj);
}


GType password_area_get_type (void) {
	static volatile gsize password_area_type_id__volatile = 0;
	if (g_once_init_enter (&password_area_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PasswordAreaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) password_area_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PasswordArea), 0, (GInstanceInitFunc) password_area_instance_init, NULL };
		GType password_area_type_id;
		password_area_type_id = g_type_register_static (TYPE_CREDENTIALS_AREA, "PasswordArea", &g_define_type_info, 0);
		g_once_init_leave (&password_area_type_id__volatile, password_area_type_id);
	}
	return password_area_type_id__volatile;
}



