/* TimeLabel.c generated by valac 0.36.1, the Vala compiler
 * generated from TimeLabel.vala, do not modify */

/*
* Copyright (c) 2011-2017 elementary LLC (http://launchpad.net/pantheon-greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
*/

#include <glib.h>
#include <glib-object.h>
#include <clutter-gtk/clutter-gtk.h>
#include <gtk/gtk.h>
#include <clutter/clutter.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_TIME_LABEL (time_label_get_type ())
#define TIME_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIME_LABEL, TimeLabel))
#define TIME_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIME_LABEL, TimeLabelClass))
#define IS_TIME_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIME_LABEL))
#define IS_TIME_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIME_LABEL))
#define TIME_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIME_LABEL, TimeLabelClass))

typedef struct _TimeLabel TimeLabel;
typedef struct _TimeLabelClass TimeLabelClass;
typedef struct _TimeLabelPrivate TimeLabelPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _TimeLabel {
	GtkClutterActor parent_instance;
	TimeLabelPrivate * priv;
};

struct _TimeLabelClass {
	GtkClutterActorClass parent_class;
};

struct _TimeLabelPrivate {
	GtkLabel* date_label;
	GtkLabel* time_label;
	GtkLabel* pm_label;
};


static gpointer time_label_parent_class = NULL;

GType time_label_get_type (void) G_GNUC_CONST;
#define TIME_LABEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TIME_LABEL, TimeLabelPrivate))
enum  {
	TIME_LABEL_DUMMY_PROPERTY
};
TimeLabel* time_label_new (void);
TimeLabel* time_label_construct (GType object_type);
static gboolean time_label_update_time (TimeLabel* self);
static gboolean _time_label_update_time_gsource_func (gpointer self);
static GObject * time_label_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void time_label_finalize (GObject * obj);


static gboolean _time_label_update_time_gsource_func (gpointer self) {
	gboolean result;
	result = time_label_update_time ((TimeLabel*) self);
	return result;
}


TimeLabel* time_label_construct (GType object_type) {
	TimeLabel * self = NULL;
	self = (TimeLabel*) g_object_new (object_type, NULL);
	time_label_update_time (self);
	clutter_threads_add_timeout ((guint) 5000, _time_label_update_time_gsource_func, self);
	return self;
}


TimeLabel* time_label_new (void) {
	return time_label_construct (TYPE_TIME_LABEL);
}


static gboolean time_label_update_time (TimeLabel* self) {
	gboolean result = FALSE;
	GDateTime* date;
	GDateTime* _tmp0_;
	gchar* day_format;
	gchar* _tmp1_;
	gchar* time_format;
	gchar* _tmp2_;
	gchar* meridiem_format;
	gchar* _tmp3_;
	GtkLabel* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkLabel* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GtkLabel* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_date_time_new_now_local ();
	date = _tmp0_;
	_tmp1_ = g_strdup (_ ("%A, %B %e"));
	day_format = _tmp1_;
	_tmp2_ = g_strdup (_ ("%l:%M"));
	time_format = _tmp2_;
	_tmp3_ = g_strdup (_ (" %p"));
	meridiem_format = _tmp3_;
	_tmp4_ = self->priv->date_label;
	_tmp5_ = g_date_time_format (date, day_format);
	_tmp6_ = _tmp5_;
	gtk_label_set_label (_tmp4_, _tmp6_);
	_g_free0 (_tmp6_);
	_tmp7_ = self->priv->time_label;
	_tmp8_ = g_date_time_format (date, time_format);
	_tmp9_ = _tmp8_;
	gtk_label_set_label (_tmp7_, _tmp9_);
	_g_free0 (_tmp9_);
	_tmp10_ = self->priv->pm_label;
	_tmp11_ = g_date_time_format (date, meridiem_format);
	_tmp12_ = _tmp11_;
	gtk_label_set_label (_tmp10_, _tmp12_);
	_g_free0 (_tmp12_);
	result = TRUE;
	_g_free0 (meridiem_format);
	_g_free0 (time_format);
	_g_free0 (day_format);
	_g_date_time_unref0 (date);
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GObject * time_label_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	TimeLabel * self;
	GtkContainer* container_widget;
	GtkWidget* _tmp0_;
	GtkContainer* _tmp1_;
	GtkGrid* layout;
	GtkGrid* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkLabel* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkGrid* _tmp15_;
	GtkLabel* _tmp16_;
	GtkGrid* _tmp17_;
	GtkLabel* _tmp18_;
	GtkGrid* _tmp19_;
	GtkLabel* _tmp20_;
	GtkGrid* _tmp21_;
	GtkContainer* _tmp22_;
	GtkGrid* _tmp23_;
	parent_class = G_OBJECT_CLASS (time_label_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TIME_LABEL, TimeLabel);
	_tmp0_ = gtk_clutter_actor_get_widget ((GtkClutterActor*) self);
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_container_get_type (), GtkContainer));
	container_widget = _tmp1_;
	_tmp2_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp2_);
	layout = _tmp2_;
	_tmp3_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->date_label);
	self->priv->date_label = _tmp3_;
	_tmp4_ = self->priv->date_label;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_add_class (_tmp5_, "h2");
	_tmp6_ = self->priv->date_label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp6_, TRUE);
	_tmp7_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->time_label);
	self->priv->time_label = _tmp7_;
	_tmp8_ = self->priv->time_label;
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
	gtk_style_context_add_class (_tmp9_, "time");
	_tmp10_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->pm_label);
	self->priv->pm_label = _tmp10_;
	_tmp11_ = self->priv->pm_label;
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
	gtk_style_context_add_class (_tmp12_, "time");
	_tmp13_ = self->priv->pm_label;
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
	gtk_style_context_add_class (_tmp14_, "pm");
	_tmp15_ = layout;
	_tmp16_ = self->priv->date_label;
	gtk_grid_attach (_tmp15_, (GtkWidget*) _tmp16_, 0, 0, 2, 1);
	_tmp17_ = layout;
	_tmp18_ = self->priv->time_label;
	gtk_grid_attach (_tmp17_, (GtkWidget*) _tmp18_, 0, 1, 1, 1);
	_tmp19_ = layout;
	_tmp20_ = self->priv->pm_label;
	gtk_grid_attach (_tmp19_, (GtkWidget*) _tmp20_, 1, 1, 1, 1);
	_tmp21_ = layout;
	gtk_widget_show_all ((GtkWidget*) _tmp21_);
	_tmp22_ = container_widget;
	_tmp23_ = layout;
	gtk_container_add (_tmp22_, (GtkWidget*) _tmp23_);
	_g_object_unref0 (layout);
	_g_object_unref0 (container_widget);
	return obj;
}


static void time_label_class_init (TimeLabelClass * klass) {
	time_label_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TimeLabelPrivate));
	G_OBJECT_CLASS (klass)->constructor = time_label_constructor;
	G_OBJECT_CLASS (klass)->finalize = time_label_finalize;
}


static void time_label_instance_init (TimeLabel * self) {
	self->priv = TIME_LABEL_GET_PRIVATE (self);
}


static void time_label_finalize (GObject * obj) {
	TimeLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TIME_LABEL, TimeLabel);
	_g_object_unref0 (self->priv->date_label);
	_g_object_unref0 (self->priv->time_label);
	_g_object_unref0 (self->priv->pm_label);
	G_OBJECT_CLASS (time_label_parent_class)->finalize (obj);
}


GType time_label_get_type (void) {
	static volatile gsize time_label_type_id__volatile = 0;
	if (g_once_init_enter (&time_label_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TimeLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) time_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TimeLabel), 0, (GInstanceInitFunc) time_label_instance_init, NULL };
		GType time_label_type_id;
		time_label_type_id = g_type_register_static (gtk_clutter_actor_get_type (), "TimeLabel", &g_define_type_info, 0);
		g_once_init_leave (&time_label_type_id__volatile, time_label_type_id);
	}
	return time_label_type_id__volatile;
}



